package ProjectElectricLocomotive.src.CollectionGenericObjects;

import java.util.Optional;

public class MassiveGenericObjects<T extends Object> implements ICollectionGenericObjects<T>
{
    private T[] _collection;

    @Override
    public int getCount(){
        return _collection.length;
    }

    @Override
    public void setMaxCount(int maxCount) {
        if (maxCount > 0) {
            _collection = (T[]) new Object[maxCount];
        }
    }

    public MassiveGenericObjects() {
        _collection = (T[]) new Object[0]; // Create an empty array of type T
    }
    @Override
    public int insert(T obj) {
        return insert(obj, 0);
    }

    @Override
    public int insert(T obj, int position) {
        for(int i = position; i < getCount(); i++)
        {
            if (_collection[i] == null)
            {
                _collection[i] = obj;
                return i;
            }
        }
        for(int i = position - 1; i >= 0; --i)
        {
            if (_collection[i] == null)
            {
                _collection[i] = obj;
                return i;
            }
        }
        return -1;
    }

    @Override
    public T remove(int position) {
        if (position < 0 || position >= getCount()) return null;
        if (_collection[position] != null)
        {
            T obj = _collection[position];
            _collection[position] = null;
            return obj;

        }
        return null;
    }

    @Override
    public T get(int position) {
        if(position >= 0 && position < getCount())
        {
            return _collection[position];
        }
        else
        {
            return null;
        }
    }
}