package ProjectElectricLocomotive.src.Forms;

import ProjectElectricLocomotive.src.CollectionGenericObjects.SpecialGenerateLocomotive;
import ProjectElectricLocomotive.src.Drawnings.*;
import ProjectElectricLocomotive.src.Entities.EntityElectricLocomotive;
import ProjectElectricLocomotive.src.Entities.EntityLocomotive;

import javax.swing.*;
import java.awt.*;
import java.util.Random;

public class DrawingGenerateLocomotive extends JPanel
{
    private final FormGenerateLocomotive field;
    protected SpecialGenerateLocomotive _generateLocomotive;
    private DrawingLocomotive _locomotive = null;

    public void setGenerateLocomotive()
    {
        _generateLocomotive = new SpecialGenerateLocomotive();
        for(int i = 0; i < 3; i++)
        {
            Random rnd = new Random();
            EntityLocomotive _EntityLocomotive;
            int shipNum = rnd.nextInt(2);
            switch (shipNum){
                case 1:
                    _EntityLocomotive = new EntityLocomotive(rnd.nextInt(100, 300),
                            rnd.nextInt(1000, 3000),
                            new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)));
                    break;
                default:
                    _EntityLocomotive = new EntityElectricLocomotive(rnd.nextInt(100, 300),
                            rnd.nextInt(1000, 3000),
                            new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)),
                            new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)),
                            rnd.nextBoolean(),
                            rnd.nextBoolean());
                    break;
            }
            _generateLocomotive.add(_EntityLocomotive);

            IDrawingOrnament _wheels;
            int varDecks = rnd.nextInt(3);
            switch (varDecks)
            {
                case 0:
                    _wheels = new DrawingWheels();
                    break;
                case 1:
                    _wheels = new DrawingOrnamentWheels();
                    break;
                default:
                    _wheels = new DrawningSecondOrnamentWheels();
                    break;
            }
            _wheels.SetCountWheels(rnd.nextInt(1,4));
            _generateLocomotive.add(_wheels);
        }
    }
    @Override
    protected void paintComponent(Graphics g)
    {
        if (_locomotive == null) return;
        _locomotive.DrawTransport(g);
        //repaint();
    }
    public DrawingGenerateLocomotive(FormGenerateLocomotive field) {
        this.field = field;
        setGenerateLocomotive();

    }
    public void createNewObject()
    {
        _locomotive = _generateLocomotive.createDrawingObject();
        _locomotive.SetPictureSize(field.getWidth(), field.getHeight());
        _locomotive.SetPosition(field.panelLocomotive.getWidth()/2 - 50, field.getHeight()/2 - 50);
    }
    public void insertCollection(){
        if(_locomotive == null) return;
        field._collectionForm.insertNewLocomotive(_locomotive);
        //createNewObject();
    }
}