package ProjectElectricLocomotive.src.Forms;

import ProjectElectricLocomotive.src.CollectionGenericObjects.AbstractCompany;
import ProjectElectricLocomotive.src.CollectionGenericObjects.LocomotiveDepotService;
import ProjectElectricLocomotive.src.CollectionGenericObjects.MassiveGenericObjects;
import ProjectElectricLocomotive.src.Drawnings.DrawingElectricLocomotive;
import ProjectElectricLocomotive.src.Drawnings.DrawingLocomotive;

import javax.swing.*;
import java.awt.*;
import java.util.Random;

public class DrawingLocomotiveCollection extends JPanel
{
    private final FormLocomotiveCollection field;
    private AbstractCompany _company = null;

    public DrawingLocomotiveCollection(FormLocomotiveCollection field) {
        this.field = field;
    }
    void comboBoxSelectorCompany_SelectedIndexChanged(String text)
    {
        switch (text)
        {
            case "Хранилище":
                _company = new LocomotiveDepotService(field.pictureBox.getWidth(), field.pictureBox.getHeight(), new MassiveGenericObjects<DrawingLocomotive>());
                break;
        }
    }

    public void insertNewLocomotive(DrawingLocomotive _drawingLocomotive)
    {
        if (_company == null) return;
        if (_company.add(_drawingLocomotive) != -1)
        {
            JOptionPane.showMessageDialog(null, "Объект добавлен");
            field.pictureBox.setIcon(new ImageIcon(_company.show(field.pictureBox)));
        }
        else
        {
            JOptionPane.showMessageDialog(null, "Объект не удалось добавить");
        }
    }
    private void CreateObject(String type)
    {
        if (_company == null) return;
        DrawingLocomotive _drawingLocomotive;
        Random rnd = new Random();
        switch (type)
        {
            case "DrawningLocomotive":
                _drawingLocomotive = new DrawingLocomotive(rnd.nextInt(100, 300),
                        rnd.nextInt(1000, 3000),
                        getColor(rnd));
                break;
            case "DrawningElectricLocomotive":
                _drawingLocomotive = new DrawingElectricLocomotive(rnd.nextInt(100, 300),
                        rnd.nextInt(1000, 3000),
                        getColor(rnd),
                        getColor(rnd),
                        rnd.nextBoolean(),
                        rnd.nextBoolean());
                break;
            default:
                return;
        }
        insertNewLocomotive(_drawingLocomotive);
    }
    private static Color getColor(Random random) {
        Color initialColor = new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256));
        Color selectedColor = JColorChooser.showDialog(null, "Выберите цвет", initialColor);
        if (selectedColor != null) {
            return selectedColor;
        } else {
            return initialColor;
        }
    }

    public void CreateButtonElectricLocomotiveAction(){
        CreateObject("DrawningElectricLocomotive");
    }
    public void CreateButtonLocomotiveAction(){
        CreateObject("DrawningLocomotive");
    }
    public void ButtonCreateSpecialLocomotive_Click()
    {
        FormGenerateLocomotive form = new FormGenerateLocomotive(this);
    }
    public void ButtonRemoveLocomotive_Click(JFormattedTextField maskedTextField)
    {
        if (maskedTextField.getText().isEmpty() || _company == null) return;
        int pos = Integer.parseInt(maskedTextField.getText());
        int choice = JOptionPane.showConfirmDialog(null, "Удалить объект?", "Удаление", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
        if (choice == JOptionPane.NO_OPTION) return;
        if (_company.remove(_company, pos) != null) {
            JOptionPane.showMessageDialog(null, "Объект удален");
            field.pictureBox.setIcon(new ImageIcon(_company.show(field.pictureBox)));
        } else {
            JOptionPane.showMessageDialog(null, "Не удалось удалить объект");
        }
    }
    protected void ButtonGoToCheck_Click()
    {
        if (_company == null) return;
        DrawingLocomotive locomotive = null;
        int counter = 100;
        while (locomotive == null)
        {
            locomotive = _company.GetRandomObjects();
            counter--;
            if(counter <= 0) break;
        }
        if (locomotive == null) return;
        FormElectricLocomotive form = new FormElectricLocomotive(locomotive);

    }
    protected void ButtonRefresh_Click()
    {
        if (_company == null) return;
        field.pictureBox.setIcon(new ImageIcon(_company.show(field.pictureBox)));
    }
}

