package ProjectElectricLocomotive.src.Forms;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.util.Random;

public class FormGenerateLocomotive extends JFrame
{
    protected int Width;
    private int Height;

    protected JPanel panelLocomotive;
    private JPanel panelInfoLocomotive;
    private JPanel panelButtonManage;
    private JLabel labelInfoLocomotive;
    private JPanel panelInfoWheels;
    private JLabel labelInfoWheels;
    private JButton createNewObject;
    private JButton sendObject;

    protected DrawingLocomotiveCollection _collectionForm;
    DrawingGenerateLocomotive field = new DrawingGenerateLocomotive(this);


    public FormGenerateLocomotive(DrawingLocomotiveCollection _collection){
        super("Коллекция локомотивов");
        _collectionForm = _collection;
        setSize(900,500);
        Width = getWidth();
        Height = getHeight();
        initComponents();
        RefreshWindow();
        setVisible(true);
        field.createNewObject();
    }
    private void initComponents()
    {
        panelLocomotive = new JPanel();
        panelInfoLocomotive = new JPanel();
        panelInfoWheels = new JPanel();
        labelInfoLocomotive = new JLabel();
        labelInfoWheels = new JLabel();
        panelButtonManage = new JPanel();
        createNewObject = new JButton("Сгенерировать");
        sendObject = new JButton("Отправить");

        panelLocomotive.setBorder(BorderFactory.createTitledBorder("Объект"));
        panelInfoLocomotive.setBorder(BorderFactory.createTitledBorder("Информация о локомотивах"));
        panelInfoWheels.setBorder(BorderFactory.createTitledBorder("Информация о колёсах"));
        panelButtonManage.setLayout(new GridLayout(1, 2));

        labelInfoLocomotive.setVerticalAlignment(SwingConstants.TOP);
        labelInfoLocomotive.setPreferredSize(new Dimension(Width/3, Height - 40));

        labelInfoWheels.setVerticalAlignment(SwingConstants.TOP);


        createNewObject.setPreferredSize(new Dimension(130, 30));
        sendObject.setPreferredSize(new Dimension(130, 30));

        StringBuilder sbE = new StringBuilder();
        StringBuilder sbD = new StringBuilder();
        for(int i = 0; i < 3; i++){
            sbE.append(field._generateLocomotive.getEn(i)).append("<br>").append("<br>");
            sbD.append(field._generateLocomotive.getDec(i)).append("<br>").append("<br>");
        }
        labelInfoLocomotive.setText("<html>" + sbE.toString() + "</html>");
        labelInfoWheels.setText("<html>" + sbD.toString() + "</html>");

        createNewObject.addActionListener(e->{
            field.createNewObject();
            repaint();
        });

        sendObject.addActionListener(e->{
            field.insertCollection();
            //repaint();
        });

        panelLocomotive.add(panelButtonManage);
        panelInfoLocomotive.add(labelInfoLocomotive);
        panelInfoWheels.add(labelInfoWheels);
        panelButtonManage.add(createNewObject);
        panelButtonManage.add(sendObject);
        add(panelLocomotive);
        add(panelInfoLocomotive);
        add(panelInfoWheels);

        add(field);

        addComponentListener(new ComponentAdapter() {
            @Override
            public void componentResized(ComponentEvent e) {
                super.componentResized(e);
                Width = getWidth();
                Height = getHeight();
                repaint();
                RefreshWindow();
            }
        });
    }
    public void RefreshWindow(){
        field.setLayout(new FlowLayout());
        panelLocomotive.setBounds(0, 0, Width/3, Height/3 - 40);
        panelInfoLocomotive.setBounds(Width/3, 0, Width/3, Height - 40);
        panelInfoWheels.setBounds(2 * Width/3, 0, Width/3, Height - 40);
        panelButtonManage.setBounds(10,10,panelLocomotive.getWidth() - 10, panelLocomotive.getHeight() / 6);
    }
}
