package ProjectElectricLocomotive.src.Forms;


import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.text.MaskFormatter;
import java.text.ParseException;
public class FormLocomotiveCollection extends JFrame {
    protected int Width;
    private int Height;
    private JPanel groupBoxTools;
    private JButton buttonAddElectricLocomotive;
    private JButton buttonAddLocomotive;
    private JComboBox<String> comboBoxSelectorCompany;
    private JButton buttonRefresh;
    private JButton buttonGoToCheck;
    private JButton buttonRemoveLocomotive;
    private JButton buttonCreateSpecialLocomotive;
    private JFormattedTextField maskedTextBoxPosition;
    protected JLabel pictureBox;

    DrawingLocomotiveCollection field = new DrawingLocomotiveCollection(this);

    public FormLocomotiveCollection(){
        super("Коллекция локомотивов");
        setSize(900,500);
        Width = getWidth();
        Height = getHeight();
        initComponents();
        RefreshWindow();
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setVisible(true);
    }

    private void initComponents() {
        groupBoxTools = new JPanel();
        buttonAddElectricLocomotive = new JButton("Добавление электровоза");
        buttonAddLocomotive = new JButton("Добавление локомотива");
        comboBoxSelectorCompany = new JComboBox<>();
        buttonRefresh = new JButton("Обновить");
        buttonGoToCheck = new JButton("Передать на тесты");
        buttonRemoveLocomotive = new JButton("Удалить локомотив");
        buttonCreateSpecialLocomotive = new JButton("Сгенерировать локомотив");
        maskedTextBoxPosition = createMaskedTextField();
        pictureBox = new JLabel();

        comboBoxSelectorCompany.addActionListener(e -> {
            field.comboBoxSelectorCompany_SelectedIndexChanged((String) comboBoxSelectorCompany.getSelectedItem());
        });
        comboBoxSelectorCompany.addItem("");
        comboBoxSelectorCompany.addItem("Хранилище");

        buttonAddLocomotive.addActionListener(e->{
            field.CreateButtonLocomotiveAction();
            repaint();
        });

        buttonAddElectricLocomotive.addActionListener(e->{
            field.CreateButtonElectricLocomotiveAction();
            repaint();
        });
        buttonRemoveLocomotive.addActionListener(e->{
            field.ButtonRemoveLocomotive_Click(maskedTextBoxPosition);
            repaint();
        });
        buttonGoToCheck.addActionListener(e->{
            field.ButtonGoToCheck_Click();
            repaint();
        });
        buttonRefresh.addActionListener(e->{
            field.ButtonRefresh_Click();
            repaint();
        });
        buttonCreateSpecialLocomotive.addActionListener(e->{
            field.ButtonCreateSpecialLocomotive_Click();
            repaint();
        });


        groupBoxTools.setBorder(BorderFactory.createTitledBorder("Инструменты"));
        groupBoxTools.setLayout(new GridLayout(8, 1));
        groupBoxTools.add(comboBoxSelectorCompany);
        groupBoxTools.add(buttonAddLocomotive);
        groupBoxTools.add(buttonAddElectricLocomotive);
        groupBoxTools.add(maskedTextBoxPosition);
        groupBoxTools.add(buttonRemoveLocomotive);
        groupBoxTools.add(buttonGoToCheck);
        groupBoxTools.add(buttonCreateSpecialLocomotive);

        groupBoxTools.add(buttonRefresh);

        add(groupBoxTools);
        add(pictureBox);
        add(field);

        addComponentListener(new ComponentAdapter() {
            @Override
            public void componentResized(ComponentEvent e) {
                super.componentResized(e);
                Width = getWidth();
                Height = getHeight();
                repaint();
                RefreshWindow();

            }
        });


    }

    private JFormattedTextField createMaskedTextField() {
        try {
            MaskFormatter formatter = new MaskFormatter("##");
            formatter.setPlaceholderCharacter('_');
            JFormattedTextField maskedTextField = new JFormattedTextField(formatter);
            maskedTextField.setFocusLostBehavior(JFormattedTextField.PERSIST);
            return maskedTextField;
        } catch (ParseException e) {
            e.printStackTrace();
            return new JFormattedTextField();
        }
    }
    public void RefreshWindow(){
        field.setLayout(new FlowLayout());
        groupBoxTools.setBounds(Width - 210, 0, 190, Height - 40);
        pictureBox.setBounds(0,0,Width - 210, Height - 40);
    }
}
