package ProjectElectricLocomotive.src.MovementStrategy;

public class MoveToBorder extends AbstractStrategy
{
    @Override
    protected void moveToTarget()
    {
        ObjectParameters objParams = getObjectParameters();
        if (objParams == null)
        {
            return;
        }
        int diffX = objParams.getRightBorder() - fieldWidth;
        if (Math.abs(diffX) > GetStep())
        {
            if (diffX > 0) MoveLeft();
            else MoveRight();
        }
        int diffY = objParams.getDownBorder() - fieldHeight;
        if (Math.abs(diffY) > GetStep())
        {
            if (diffY > 0) MoveUp();
            else MoveDown();
        }
    }

    @Override
    protected boolean isTargetDestination() {
        ObjectParameters objParams = getObjectParameters();
        if (objParams == null)
        {
            return false;
        }
        return objParams.getRightBorder() + GetStep() >= fieldWidth && objParams.getDownBorder() + GetStep() >= fieldHeight;
    }
}