package ProjectElectricLocomotive.src.MovementStrategy;

import ProjectElectricLocomotive.src.DirectionType;
import ProjectElectricLocomotive.src.Drawnings.DrawingLocomotive;

public class MoveableLocomotive implements IMoveableObject {
    private DrawingLocomotive _locomotive = null;
    public MoveableLocomotive(DrawingLocomotive drawingLocomotive)
    {
        _locomotive = drawingLocomotive;
    }
    public ObjectParameters getObjectPosition() {
        if (_locomotive == null || _locomotive.GetEntityLocomotive() == null || _locomotive.getPosX() == null || _locomotive.getPosY() == null) {
            return null;
        }

        return new ObjectParameters(_locomotive.getPosX(), _locomotive.getPosY(), _locomotive.getWidth(), _locomotive.getHeight());
    }
    public int getStep() {
        if(_locomotive == null || _locomotive.GetEntityLocomotive() == null) return 0;
        return (int)(_locomotive.GetEntityLocomotive().Step);
    }

    public boolean tryMoveObject(MovementDirection direction) {
        if (_locomotive == null || _locomotive.GetEntityLocomotive() == null) {
            return false;
        }

        DirectionType directionType = getDirectionType(direction);
        return _locomotive.MoveTransport(directionType);
    }

    private DirectionType getDirectionType(MovementDirection direction) {
        switch (direction) {
            case Left:
                return DirectionType.Left;
            case Right:
                return DirectionType.Right;
            case Up:
                return DirectionType.Up;
            case Down:
                return DirectionType.Down;
            default:
                return DirectionType.Unknown;
        }
    }
}
